package ru.dbotthepony.mc.otm.capability;

import javax.annotation.Nonnull;
import java.math.BigDecimal;

public interface IMatterHandler {
	enum MatterDirection {
		RECEIVE, // consumer
		EXTRACT, // producer
		BIDIRECTIONAL // storage
	}

	@Nonnull
	BigDecimal getStoredMatter();
	@Nonnull
	BigDecimal getMaxStoredMatter();

	@Nonnull
	BigDecimal receiveMatterOuter(BigDecimal howMuch, boolean simulate);
	@Nonnull
	BigDecimal receiveMatterInner(BigDecimal howMuch, boolean simulate);

	@Nonnull
	BigDecimal extractMatterOuter(BigDecimal howMuch, boolean simulate);
	@Nonnull
	BigDecimal extractMatterInner(BigDecimal howMuch, boolean simulate);

	@Nonnull
	MatterDirection getDirection();

	@Nonnull
	default BigDecimal getMissingMatter() {
		return getMaxStoredMatter().subtract(getStoredMatter());
	}
}
